<?php

namespace FiloBlu\ExtMailChimp\Plugin\Model;

use Magento\Framework\App\ObjectManager;
use Magento\Framework\App\ResourceConnection;

/**
 * Class Subscriber
 * @package FiloBlu\ExtMailChimp\Plugin\Model
 */
class Subscriber {

    /**
     * @param \Magento\Newsletter\Model\Subscriber $subject
     * @param \Magento\Newsletter\Model\Subscriber $subscriber
     * @param $modelId
     * @param null $field
     * @return mixed
     */
    public function afterLoad($subject, $subscriber, $modelId, $field = null)
    {
        $objectManager = ObjectManager::getInstance();
        /** @var  ResourceConnection $resourceConnection */
        $resourceConnection = $objectManager->get(ResourceConnection::class);
        $connection = $resourceConnection->getConnection();

        $select = $connection
            ->select()
            ->from($connection->getTableName('filoblu_newsletter_subscriber_info'))
            ->where("subscriber_id = :subscriber_id");

        $row = $connection->fetchRow($select, [':subscriber_id' => $subscriber->getId()]);

        if ($row === null) {
            return $subscriber;
        }

        foreach ($row as $key => $value) {
            $subscriber->setData("filoblu_{$key}", $value);
        }

        return $subscriber;
    }
}
